*******************************************
* PROGRAMADO EN HMG 3.0.46 EL 09/01/2024  *
* PROGRAMADO PARA BINGO DE 75 BOLAS       *
* PARA JUGAR ENTRE AMIGOS O FAMILIA       *
*******************************************

#include "HMG.CH"

//SpVoice Flags
#define  SVSFDefault            0
#define  SVSFlagsAsync          1
#define  SVSFPurgeBeforeSpeak   2
#define  SVSFIsFilename         4
#define  SVSFIsXML              8
#define  SVSFIsNotXML           16
#define  SVSFPersistXML         32


* SCREEN 1360x768

*-------------------------------------*
FUNCTION MAIN()
*-------------------------------------*
SET TOOLTIPSTYLE BALLOON

Public oVoice := CreateObject( "SAPI.SpVoice" )
Public cFileName 

DEFINE WINDOW PRINCE AT 0,0 WIDTH 0 HEIGHT 0 BACKCOLOR {0,125,250} NOCAPTION MAIN 
    @ 000,000 LABEL L0 ;
	          VALUE "JUGANDO BINGO EN CASA" ;
			  WIDTH 1200 HEIGHT 99 ;
			  FONT "ALGERIAN" SIZE 72 BOLD UNDERLINE  ITALIC ;  
			  FONTCOLOR WHITE TRANSPARENT

*----------------------------------- Mustafa ---------------------------------------------------*

   IF FILE( "Counter.mem" )
      RESTORE FROM Counter.mem ADDITIVE
    ELSE
      COUN = 0
      SAVE ALL LIKE coUn* TO Counter.mem
   ENDIF
  
   cFileName := "Cartones\" + STRZERO( coUn, 4 )

   @ 482,057 IMAGE CARTONE PICTURE cFileName + ".Png"  WIDTH 860 HEIGHT 193 STRETCH   // <--- FONDO CARTON --> HIDE

   xMarcaCarton()    //---> Ver _Apoyo1.prg

*-----------------------------------------------------------------------------------------------*



    @ 5 ,1200 LABEL L1 ;
              VALUE "" ;
              WIDTH 111 HEIGHT 99 ;
              FONT "ALGERIAN" SIZE 72 BOLD ;  
              FONTCOLOR GREEN BACKCOLOR {0,125,250}

    @ 690,0   LABEL L2 ;
              VALUE "" ;
              WIDTH 850 HEIGHT 40 ;
              FONT "ALGERIAN" SIZE 28 BOLD ;  
              FONTCOLOR BLUE BACKCOLOR {0,125,250}

              
    @ 690 ,1027 SLIDER Volumen;  
              RANGE 0 , 100  VALUE oVoice:Volume ; 
	      WIDTH  235 HEIGHT 30  TOOLTIP "Volumen Speech";
	      ON CHANGE Volume()

        @ 655,0949 IMAGE ZCarton PICTURE "Resource/zoom.bmp" WIDTH 30 HEIGHT 30 ACTION ViewPik() TOOLTIP "Zoom Cartones" STRETCH 
	@ 655,0984 BUTTON BUTTON_0 CAPTION "CARTONES"  WIDTH 75 HEIGHT 30 ONCLICK CARTONES()			 
	@ 655,1065 BUTTON BUTTON_1 CAPTION "S T A R T" WIDTH 75 HEIGHT 30 ONCLICK BUSCANUME()
        @ 655,1145 BUTTON BUTTON_2 CAPTION "PAUSE"     WIDTH 75 HEIGHT 30 ONCLICK Pause()
	@ 655,1225 BUTTON BUTTON_3 CAPTION "E X I T"   WIDTH 75 HEIGHT 30 ONCLICK SALIR()

        PRINCE.CARTONE.HIDE

 	ON KEY ESCAPE ACTION SALIR()


        SETWINDOWCURSOR( PRINCE.BUTTON_0.Handle, "Resource\SmoothHand.cur" )
        SETWINDOWCURSOR( PRINCE.Label_11.Handle, "Resource\SmoothHand.cur" )
      


END WINDOW

 PRINCE.ZCarton.Hide

 Anular_X()  // <----------- Deja la "X" en HIDE de momento  //---> Ver _Apoyo1.prg


PRINCE.MAXIMIZE
PRINCE.ACTIVATE

RETURN

*-------------------------------------*
FUNCTION Volume()
*-------------------------------------*

oVoice:Volume := PRINCE.Volumen.value
Speak ( "Volumen "+ str ( oVoice:Volume ), .F. )
Return 

*-------------------------------------*
FUNCTION Speak ( cSpeak, lWait )
*-------------------------------------*

Local nFlagSpVoice
Default lWait := .T.

IF lWait
    nFlagSpVoice := SVSFDefault
ELSE
    nFlagSpVoice := SVSFlagsAsync + SVSFPurgeBeforeSpeak
ENDIF
oVoice:Speak( cSpeak, nFlagSpVoice )
Return 

*-------------------------------------*
Function Pause ()
*-------------------------------------*

PRINCE.BUTTON_2.Caption := IF( PRINCE.BUTTON_2.Caption = "PAUSE", "Continue", "PAUSE" )
DO EVENTS
Return    

*-------------------------------------*
FUNCTION BUSCANUME()
*-------------------------------------*
LOCAL nNum, nAleatorio, nCount, nLine := 0, nColumn := 0

Declare Window PRINCE


*----------------------- Mustafa --------------------------------*

   Anular_X()              // <----------- Deja la "X" en HIDE de momento  //---> Ver _Apoyo1.prg

   PRINCE.ZCarton.SHOW


   IF FILE( "Counter.mem" )
      RESTORE FROM Counter.mem ADDITIVE
   ELSE
      COUN = 0
      SAVE ALL LIKE coUn* TO Counter.mem
   ENDIF
 
   cFileName := "Cartones\" + STRZERO( coUn, 4 )

   PRINCE.CARTONE.PICTURE := cFileName + ".Png"

   PRINCE.CARTONE.SHOW        //<-------  Cartón Fondo 

   ActivaBotonX()            //---> Ver _Apoyo1.prg


*----------------------------------------------------------------*


IF PRINCE.BUTTON_1.Caption = "STOP"
   PRINCE.BUTTON_1.Caption := "S T A R T"
   PRINCE.BUTTON_2.Caption := "PAUSE"
   DO EVENTS
   RETURN
ENDIF

PRINCE.BUTTON_1.Caption := "STOP"
PRINCE.BUTTON_2.Caption := "PAUSE"
*PRINCE.BUTTON_3.Enabled := .T.
PRINCE.BUTTON_2.SetFocus

DO EVENTS

nAleatorio := {}

DO WHILE Len( nAleatorio ) < 75
    DO WHILE .T.
      nNum := HB_RANDOMINT(1,75)
      IF ASCAN ( nAleatorio, nNum ) = 0
        AAdd ( nAleatorio, nNum )
        IF _IsControlDefined ( StrZero ( nNum, 2 ) , "PRINCE" )
            DoMethod ( "PRINCE", StrZero ( nNum, 2 ), "Release" )
        ENDIF
        EXIT
      ENDIF
      DO EVENTS
   ENDDO
   DO EVENTS
ENDDO

MSGINFO ("ATENCION POR FAVOR, EMPEZARA EL JUEGO !")

FOR nCount := 1 TO Len( nAleatorio )

    DO WHILE PRINCE.BUTTON_2.Caption = "Continue"
        DO EVENTS
    ENDDO
    
    IF PRINCE.BUTTON_1.Caption = "S T A R T"
        EXIT
    ENDIF

    PINTANUME( nAleatorio [ nCount ], @nLine, @nColumn )

  @ nLine,nColumn LABEL &(StrZero ( nAleatorio [ nCount ], 2 )) PARENT PRINCE VALUE STRZero( nAleatorio [ nCount ], 2 ) WIDTH 44 HEIGHT 36 FONT "ALGERIAN" SIZE 22 BOLD FONTCOLOR BLACK BACKCOLOR {0,125,250}


   DO EVENTS
   
   PRINCE.L1.VALUE := StrZero ( nCount, 2 )
   PRINCE.L2.VALUE := SPACE(18) + "ULTIMO NUMERO QUE SALIO --->" + STRZero( nAleatorio [ nCount ], 2 )

   Speak ( nAleatorio [ nCount ] )

   DO EVENTS

  INKEY(0.85)	//  INKEY(0.5)				&& TIEMPO ENTRE UN NUMERO Y OTRO (SE LO PUEDE AMPLIAR)
   
NEXT

PRINCE.BUTTON_2.Caption := "PAUSE"
PRINCE.BUTTON_1.Caption := "S T A R T"
PRINCE.BUTTON_1.SetFocus
DO EVENTS
RETURN


*------------------------------------------------------------------------*
FUNCTION PINTANUME( nNum, nLine, nColumn )   // <====== Courtesy of edk
*------------------------------------------------------------------------*
Local nMod 

nMod := nNum / 15 
IF nMod == Int ( nMod )
    nMod --
ENDIF
nLine := ( Int( nMod ) + 1.8 ) * 072 

nMod := nNum % 15
IF nMod = 0
    nMod := 15
ENDIF

nColumn := 15 + ( nMod - 1 ) * 90
 
RETURN

*-------------------------------------*
FUNCTION SALIR
*-------------------------------------*
PRINCE.RELEASE
QUIT
RETURN

**********************************************************************************************************
























































